# sched_h.m4 serial 7
dnl Copyright (C) 2008-2016 Free Software Foundation, Inc.
dnl This file is free software; the Free Software Foundation
dnl gives unlimited permission to copy and/or distribute it,
dnl with or without modifications, as long as this notice is preserved.

dnl Written by Bruno Haible.

AC_DEFUN([gl_SCHED_H],
[
  HAVE_SCHED_H=0
  gl_CHECK_NEXT_HEADERS([sched.h])
  if test $ac_cv_header_sched_h = yes; then
     HAVE_SCHED_H=1
  fi

  HAVE_STRUCT_SCHED_PARAM=0
  SCHED_H='sched.h'

  if test "$HAVE_SCHED_H" = 1; then
    AC_CHECK_TYPE([struct sched_param],
      [HAVE_STRUCT_SCHED_PARAM=1], [HAVE_STRUCT_SCHED_PARAM=0],
      [#include <sched.h>])
  else
    dnl On OS/2 kLIBC, struct sched_param is in spawn.h.
    AC_CHECK_TYPE([struct sched_param],
      [HAVE_STRUCT_SCHED_PARAM=1], [HAVE_STRUCT_SCHED_PARAM=0],
      [#include <spawn.h>])
  fi

  dnl Ensure the type pid_t gets defined.
  AC_REQUIRE([AC_TYPE_PID_T])
  AC_SUBST([HAVE_SCHED_H])
  AC_SUBST([SCHED_H])
  AC_SUBST([HAVE_STRUCT_SCHED_PARAM])
  AM_CONDITIONAL([GL_GENERATE_SCHED_H], [test -n "$SCHED_H"])
])
